#include <pthread.h>
 
typedef struct _mymem_t {
	long avail[10];
	long inuse[10];
} mymem_t;
 
//void *mythread(void *arg) {
//	myarg_t *m = (myarg_t *) arg;
//	printf(“%d %d\n”, m->a, m->b);
//	return NULL;
//}
 
/*
 ** Methods/Functions to implement:
 */
void construct(); // This will malloc() a total of 1MB of storage, 10 malloc() calls each 100K size, to create 10 "blocks" of storage, with the starting address added to mymem's avail array. (mymem.avail[i] = ...). The inuse array elements will be initialized to 0;
void destruct();  // This will free() all of the storage obtained in construct(). All elements of each array are zeros.
long get();       // This will return an available address from the mymem avail array. If there are no more available blocks of memory, return -1; If a malloc block is given out, the value of the associated index of avail[] becomes 0 and the value of the associated index of inuse[] becomes the malloc storage block address and the function will return 0.
long release(long); // This will return (but NOT free() a malloc storage block) address from the mymem inuse array. If the value being passed in doesn't match an existing block of memory, return -1; If a malloc block is returned, the value of the associated index of avail[] becomes the malloced storage block address and the value of the associated index of inuse[] becomes 0. and the function will return 0.
display();          //This will use printf() to display the mymem struct and the values for each index of each array.

int main(int argc, char *argv[]) {
	mymem_t mymem;

    /* create tests to verify the methods/functions you implemented are correct. 
	 **A good idea: write construct() first, then display() & destruct and verify they work	
	 **Then implement get() and release() and test those functions.
	 */

}
